/*
 * lock.h
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */
#ifndef JK_LOCK_H
#define JK_LOCK_H

class Lock {
	public:
		Lock(void);
		~Lock(void);

		void read_lock(void);
		void read_unlock(void);

		void write_lock(void);
		void write_unlock(void);

	private:
		pthread_mutex_t lock;
		pthread_cond_t rd_cond, wr_cond;
		int reading;
		int writing;
		
};

#endif

